<style>
  .documents-title {
    font-weight: bold;
    font-style: italic;
  }
  .documents-content {
    padding-left: 40px;
  }

  .bloc-nocut {
    page-break-inside: avoid;
  }

  thead {
    display: table-row-group;
    page-break-inside: avoid;
  }
  tr {
      page-break-inside: avoid;
  }
  table {
      word-wrap: normal;
      page-break-inside: avoid;
  }
  table td {
      word-break: normal; /* break-all; */
  }

  table.barby-barcode { border-spacing: 0; display: inline;}
  tr.barby-row {}
  td.barby-cell { padding: 0; ;width: 2px; height: 40px; }
  td.barby-cell.on { background: #000; }
</style>

<% # @export_pdf = true %>
<% admin_config = Admin::AdminConfig.first %>

<% if @export_pdf %>
  <%= render partial: 'tools/rca_reports/export_pdf_css' %>
<% end %>
<% export_values = @export_values %>

<!-- Title -->

<div>
  <hr>
  <div style="margin: auto; display: table; width: 100%;">
    <div style="display: table-cell;"><%= customer_logo %></div>
    <div style="display: table-cell; padding: 0;">
      <h3><%= "#{t('tools.rca_reports.index.reporting')} RCA #{@rca.reference}" %></h3>
      <h5><%= "#{t('tools.rca_reports.index.event')} : #{@rca.title}" %></h5>
      <h5><%= "#{t('tools.rca_reports.index.edition_date')} : #{Date.today}" %></h5>
    </div>
    <div style="display: table-cell;">
      <% if admin_config&.option_attribute('rca_cod') == true %>
      <%= Rcas::GenerateBarcode.new(admin_config.option_attribute('rca_cod_type')).call("#{admin_config.option_attribute('rca_cod_txt')}#{@rca.reference}") %>
      <% end %>
    </div>
    <div style="display: table-cell; text-align: right;">
      <%= prowhy_logo %>
    </div>
  </div>
</div>


<!-- Ancres -->
<div id="report-ancres" style='float: right; right:20px;'>
  <% @rca.steps.each do |step| %>
    <a href="#report-bloc-<%= step.id %>" class='btn btn-light btn-outline-dark btn-xs' data-turbolinks="false"><%= step.name%></a>
    <%#= link_to step.name, tools_rca_reports_url(rca: @rca, step_tool: current_user.get_session(:active_step_tool), anchor: "report-bloc-#{step.id}"), 'data-turbolinks': "false" %>
  <% end %>
  <% if !@export_pdf %>
    <a href="#report-bloc-0" class='btn btn-light btn-outline-dark btn-xs' data-turbolinks="false"> COM </a>
  <% end %>
</div><br/><br/>

<%= form_with url: tools_rca_reports_url(rca: @rca, format: :pdf), method: :get, local: true do |form| %>

    <div class="admin-col-repport">
      INFOS

      <%= form.submit 'Export PDF', class: 'btn btn-light btn-outline-dark btn-xs', style: 'float: right;',
                                    formtarget: :_blank unless @export_pdf %>

      <% if !@export_pdf && !@export_docker %>
        <span class='btn btn-xs btn-light' style='float: right;'>
          <%= select_tag 'page_format[page_size]', options_for_select(['A5', 'A4', 'A3', 'A2'], 'A4') %>

          <%= radio_button_tag 'page_format[orientation]', 'Portrait', true %>
          <%= label_tag "page_format[orientation]_Portrait", t('.portrait'), style: 'margin:0;' %>

          <%= radio_button_tag 'page_format[orientation]', 'Landscape', false %>
          <%= label_tag "page_format[orientation]_Landscape", t('.landscape'), style: 'margin:0;' %>
        </span>
      <% end %>
    </div>

    <div class="admin-col-content">
      <!-- DATE <%#= Date.today %>
      <hr> -->
      <%= render partial: 'rcas/show', locals: {export_values: export_values, form: form} %>

      <% tools_documents = @rca.tools_documents.by_step_role_id(0) %>
      <% if !tools_documents.empty? && (!@export_pdf || (export_values['docs'] && export_values['docs']['all'])) %>
        <div class="admin-col">
          <div class="admin-col-content">
            <div class='documents-title'>
              <%= check_box_tag "export_values[docs][all]", 'export', export_values['docs']['all'], class: 'export_values_docs', 'attr-step-id': 'step_0'  unless @export_pdf %>
              Documents
            </div>
            <div class="documents-content" id='<%= "report_step_0_docs" %>'>
              <% tools_documents.each do |tools_doc| %>
                <% next if @export_pdf && !export_values['docs'][tools_doc.id.to_s] %>
                <div>
                  <%= check_box_tag "export_values[docs][#{tools_doc.id}]", 'export', export_values['docs'][tools_doc.id.to_s] unless @export_pdf %>
                  <%= "#{tools_doc.name} : #{tools_doc.file&.filename}" %>
                </div>
              <% end %>
            </div>
          </div>
        </div>
      <% end %>

      <% tools_images = @rca.tools_images.by_step_role_id(0) %>
      <% if !tools_images.empty? && (!@export_pdf || (export_values['images'] && export_values['images']['all'])) %>
        <div class="admin-col">
          <div class="admin-col-content">
            <div class='documents-title'>
              <%= check_box_tag "export_values[images][all]", 'export', export_values['images']['all'], class: 'export_values_images', 'attr-step-id': 'step_0'  unless @export_pdf %>
              Images
            </div>
            <div class="documents-content" id='<%= "report_step_0_images" %>'>
              <table>
              <% tools_images.each do |tools_img| %>
                <% next if @export_pdf && !export_values['images'][tools_img.id.to_s] %>
                <tr>
                  <td>
                    <%= check_box_tag "export_values[images][#{tools_img.id}]", 'export', export_values['images'][tools_img.id.to_s], class: 'export_values_images', 'attr-step-id': "img_#{tools_img.id}" unless @export_pdf %>
                    <%= tools_img.name %>
                    <br>
                    <span class='<%= "report_img_#{tools_img.id}_images" %>'>
                      <%= tools_img.description if export_values['images'][tools_img.id.to_s] %>
                    </span>
                  </td>
                  <td>
                    <div class='<%= "report_img_#{tools_img.id}_images" %>'>
                    <% aff, show = file_preview(tools_img.file, sx: 500, sy: 500, show_filename: false) %>
                      <% if tools_img.file&.attached? %>
                        <%= aff.html_safe %>
                      <% end %>
                    </div>
                  </td>
                </tr>
              <% end %>
              </table>
            </div>
          </div>
        </div>
      <% end %>
    </div>


  <%= hidden_field_tag 'rca', @rca.id %>

  <!-- RCA STEPS -->
  <% @rca.steps.each do |step| %>
    <% next if @export_pdf && !export_values[step.id.to_s]['step'] %>
    <div id='<%= "report-bloc-#{step.id}" %>'>
      <div class="admin-col-repport bloc-nocut">
        <%= check_box_tag "export_values[#{step.id}][step]", 'export', export_values[step.id.to_s]['step'], class: 'export_values_step', 'attr-step-id': step.id unless @export_pdf%>
        <%= t('.step') %> <%= step.name %> : <%= @rca.step_advancement(step) %>
        <%= step_advancement(@rca, step) %>

        <a href="#" class='btn btn-light btn-outline-dark btn-xs' style='float:right;' data-turbolinks="false"> UP </a>
      </div>

      <div id='<%= "report_step_#{step.id}" %>' style='<%= export_values[step.id.to_s]['step'] ? "" : "display: none;" %>'>
        <% step.step_tools.each do |step_tool| %>
          <% next if @export_pdf && !export_values[step.id.to_s][step_tool.id.to_s]&.[]('all') %>
          <div class="admin-col bloc-nocut">
            <div class="admin-col-title admin-col-title-grey">
              <%= check_box_tag "export_values[#{step.id}][#{step_tool.id}][all]", 'export', export_values[step.id.to_s][step_tool.id.to_s]['all'], class: 'export_values_step_tool', 'attr-step-tool-id': step_tool.id unless @export_pdf %>
              <%= step_tool.name %>
            </div>
            <div class="admin-col-content" id='<%= "report_step_tool_#{step_tool.id}" %>'  style='<%= export_values[step.id.to_s][step_tool.id.to_s]['all'] ? "" : "display: none;" %>'>
              <%= step_tool_show_report(@rca, step_tool, export_values[step.id.to_s][step_tool.id.to_s]) %>
            </div>
          </div>
        <% end %>

        <% tools_documents = @rca.tools_documents.by_step_role_id(step.step_role_id) %>
        <% if !tools_documents.empty? && (!@export_pdf || (export_values[step.id.to_s]['docs'] && export_values[step.id.to_s]['docs']['all'])) %>
          <div class="admin-col">
            <div class="admin-col-content">
              <div class='documents-title'>
                <%= check_box_tag "export_values[#{step.id}][docs][all]", 'export', export_values[step.id.to_s]['docs']['all'], class: 'export_values_docs', 'attr-step-id': "step_#{step.id}"  unless @export_pdf %>
                Documents
              </div>
              <div class="documents-content" id='<%= "report_step_#{step.id}_docs" %>'>
                <% tools_documents.each do |tools_doc| %>
                  <% next if @export_pdf && !export_values[step.id.to_s]['docs'][tools_doc.id.to_s] %>

                  <div>
                    <%= check_box_tag "export_values[#{step.id}][docs][#{tools_doc.id}]", 'export', export_values[step.id.to_s]['docs'][tools_doc.id.to_s] unless @export_pdf %>
                    <%= "#{tools_doc.name} : #{tools_doc.file&.filename}" %>
                  </div>
                <% end %>
              </div>
            </div>
          </div>
        <% end %>

        <% tools_images = @rca.tools_images.by_step_role_id(step.step_role_id) %>
        <% if !tools_images.empty? && (!@export_pdf || (export_values[step.id.to_s]['images'] && export_values[step.id.to_s]['images']['all'])) %>
          <div class="admin-col">
            <div class="admin-col-content">
              <div class='documents-title'>
                <%= check_box_tag "export_values[#{step.id}][images][all]", 'export', export_values[step.id.to_s]['images']['all'], class: 'export_values_images', 'attr-step-id': "step_#{step.id}"  unless @export_pdf %>
                Images
              </div>
              <div class="documents-content" id='<%= "report_step_#{step.id}_images" %>'>
                <table>
                <% tools_images.each do |tools_img| %>
                  <% next if @export_pdf && !export_values[step.id.to_s]['images'][tools_img.id.to_s] %>
                  <tr>
                    <td>
                      <%= check_box_tag "export_values[#{step.id}][images][#{tools_img.id}]", 'export', export_values[step.id.to_s]['images'][tools_img.id.to_s], class: 'export_values_images', 'attr-step-id': "img_#{tools_img.id}" unless @export_pdf %>
                      <%= tools_img.name %>
                      <br>
                      <span class='<%= "report_img_#{tools_img.id}_images" %>'>
                        <%= tools_img.description %>
                      </span>
                    </td>
                    <td>
                      <div class='<%= "report_img_#{tools_img.id}_images" %>'>
                        <% aff, show = file_preview(tools_img.file, sx: 500, sy: 500, show_filename: false) %>
                        <% if tools_img.file&.attached? %>
                          <%= aff.html_safe %>
                        <% end %>
                      </div>
                    </td>
                  </tr>
                <% end %>
                </table>
              </div>
            </div>
          </div>
        <% end %>

      </div>
    </div>
  <% end %>
<% end %>

<!-- Prowhy Credit
<%# if @export_pdf %>
  <div class="admin-col">
    <i><%#= t('tools.rca_reports.index.prowhy_ref') %> - www.prowhy.org</i>
  </div>
<%# end %>
-->

<!-- Zone communication -->
<% if !@export_pdf %>
  <div id='report-bloc-0' class="admin-col">
    <div class='admin-col-title admin-col-title-step'>Communication</div>
    <div class="admin-col-content">
      <%= form_with url: tools_rca_report_comm_path, method: :get do |form| %>
        <%= hidden_field_tag 'rca', @rca.id %>
        <div class="row">
          <div class="col-sm-6">
            <% @rca.people.uniq.each do |person| %>
              <%= render partial: 'report_one_person', locals: {person: person} %>
            <% end %>

            <div>
              <hr>
              <h5><%= t('.dest') %></h5>
              <div id="report-add-users">
              </div>

              <div>
                <%#= link_to 'Add person', tools_rca_report_add_person_path(rca: @rca.id), remote: true, class: 'btn btn-light btn-outline-dark' %>
                <%= helper_person_choose(nil, 'person', nil, {url_submit: tools_rca_report_add_person_do_path(rca: @rca.id)}) %>
              </div>
            </div>
          </div>
          <div class="col-sm-6">
            <i><%= t('.msg_text') %></i><br>
            <%= text_area_tag 'mail[content]', "", rows: 5, cols: 50 %><br>
            <i><%= t('.msg_link_rca') %></i>
            <%= check_box_tag 'mail[rca]', true, true %><br>
            <i><%= t('.msg_link_pdf') %></i>
            <%= check_box_tag 'mail[pdf]', true, true %><br>
            <!--
              + Ajouter le truc qui tourne en attendant que les mails soient envoyés, + le retour de réussite ou non.
            -->
            <%= send_mail_submit_tag %>
          </div>
        </div>
      <% end %>
    </div>
  </div>
<% end %>

<script>
  $(function(){
    // Steps
    // $('.export_values_step').each(function(){
    // });

    $('.export_values_step').on('click', function(){
      let step_id = $(this).attr('attr-step-id');
      console.log('click : ');
      console.log(step_id);
      if ($(this).is(':checked')) {
        $('#report_step_'+step_id).show();
      }
      else {
        $('#report_step_'+step_id).hide();
      }
    });

    // Step Tools
    // $('.export_values_step_tool').each(function(){
    // });

    $('.export_values_step_tool').on('click', function(){
      let step_tool_id = $(this).attr('attr-step-tool-id');
      console.log('click step tool : ');
      console.log(step_tool_id);
      if ($(this).is(':checked')) {
        $('#report_step_tool_'+step_tool_id).show();
      }
      else {
        $('#report_step_tool_'+step_tool_id).hide();
      }
    });

    // Docs
    $('.export_values_docs').on('click', function(){
      let step_id = $(this).attr('attr-step-id');
      console.log('click step : ');
      console.log(step_id);
      if ($(this).is(':checked')) {
        $('#report_'+step_id+'_docs').show();
      }
      else {
        $('#report_'+step_id+'_docs').hide();
      }
    });

    // Images
    $('.export_values_images').on('click', function(){
      let step_id = $(this).attr('attr-step-id');
      console.log('click step : ');
      console.log(step_id);
      if ($(this).is(':checked')) {
        $('#report_'+step_id+'_images').show();
        $('.report_'+step_id+'_images').show();
      }
      else {
        $('#report_'+step_id+'_images').hide();
        $('.report_'+step_id+'_images').hide();
      }
    });

    // Tasks
    Packs.tasks_pack.tasks_ancestry();
  });
</script>
